#include <stdio.h>
#include <string.h>

int isComment(const char *s){
  if(s[0]=='\0'||!strncmp(s, "//", 2)||!strncmp(s, "^^", 4)){return 1;}
  return 0;
}
int isSavepoint(const char *s){
  return !strncmp(s, "(SAVEPOINT)", 11);
}
int isGFade(const char *s){
  return !strncmp(s, "iʈÁj", 10);
}

int isCGFlag(const char *s){
  return !strncmp(s, "(CGFLAG)", 8);
}
int isSCFlag(const char *s){
  return !strncmp(s, "(SCFLAG)", 8);
}
int isMidi(const char *s){
  return !strncmp(s, "ilhcj", 10);
}
int isWave(const char *s){
  return !strncmp(s, "iv`uj", 10);
}

int isCG(const char *s){
  return !strncmp(s, "ibfj", 8);
}
int isGOff(const char *s){
  return !strncmp(s, "iÓ]j", 8);
}

int isWait(const char *s){
  return !strncmp(s, "iv`hsj", 12);
}
int isSpace(const char *s){
  return !strncmp(s, "iro`bdj", 14);
}

int isSelect(const char *s){
  return !strncmp(s, "iIj", 8);
}
int isSelectEnd(const char *s){
  return !strncmp(s, "(II)", 10);
}
int isJump(const char *s){
  return !strncmp(s, "(JUMP)", 6);
}
int isIndex(const char *s){
  return !strncmp(s, "(INDEX ", 7);
}

int isEnd(const char *s){
  return !strncmp(s, "idmcj", 10);
}

int isNextline(const char *s){
  if(!strncmp(s, "", 2)){return 1;};
  return 0;
}

int isNextpage(const char *s){
  if(!strncmp(s, "", 2)){return 1;};
  return 0;
}

void generate(FILE **fp, char *s){
  static unsigned long index=1000;
  int n=0;
  fprintf(*fp, "STRING ID %d \"", index++);
  while(s[n]!='\0'){
    if(s[n]==' '){
    }else{
      fputc(s[n],*fp);
      if(s[n]=='\\'){fputc('\\',*fp);}
    }
    n++;
  }
  fprintf(*fp, "\"\n");
}

int main(int argc, char *argv[])
{
  FILE *fp,*fp2;
  char buf[1024];
  char buf2[1024];
  char buf3[1024];
  static char bank[1024];
  fp=fopen(argv[1], "r");
  if(fp==NULL){fprintf(stderr, "src file open err.\n");exit(0);}
  fp2=fopen(argv[2], "w");
  if(fp2==NULL){fprintf(stderr, "dst file open err.\n");exit(0);}

  while(fgets(buf, sizeof(buf), fp)!=NULL){
    buf[strlen(buf)-1]='\0';//0x0a
    if(isComment(buf)||isSavepoint(buf)){
      //NOP
    }else if(isMidi(buf)||isWave(buf)||isCGFlag(buf)||isSCFlag(buf)){
      //SKIP NEXT LINE
      fgets(buf, sizeof(buf), fp);
    }else if(isCG(buf)){
      fgets(buf, sizeof(buf), fp);
      buf[strlen(buf)-1]='\0';//0x0a
//BEGIN OF Ё[
      int idx=1000;
      if(!strcmp(buf, "T1")){idx=1000;}
      if(!strcmp(buf, "T2")){idx=1001;}
      if(!strcmp(buf, "T3")){idx=1002;}
      if(!strcmp(buf, "T4")){idx=1003;}
      if(!strcmp(buf, "T5")){idx=1004;}
      if(!strcmp(buf, "T6")){idx=1005;}
      if(!strcmp(buf, "T7")){idx=1006;}
      if(!strcmp(buf, "T8")){idx=1007;}
      if(!strcmp(buf, "T9")){idx=1008;}
      if(!strcmp(buf, "T10")){idx=1009;}
      if(!strcmp(buf, "T11")){idx=1010;}

      if(!strcmp(buf, "P1")){idx=1011;}
      if(!strcmp(buf, "P1d")){idx=1012;}
      if(!strcmp(buf, "P2")){idx=1013;}
      if(!strcmp(buf, "P2d")){idx=1014;}
      if(!strcmp(buf, "P3")){idx=1015;}
      if(!strcmp(buf, "P3d")){idx=1016;}
      if(!strcmp(buf, "P3n")){idx=1017;}
      if(!strcmp(buf, "P3nd")){idx=1018;}
      if(!strcmp(buf, "P4")){idx=1019;}
      if(!strcmp(buf, "P4d")){idx=1020;}
      if(!strcmp(buf, "P4n")){idx=1021;}
      if(!strcmp(buf, "P4nd")){idx=1022;}
      if(!strcmp(buf, "P5")){idx=1023;}
      if(!strcmp(buf, "P5d")){idx=1024;}
      if(!strcmp(buf, "P6")){idx=1025;}
      if(!strcmp(buf, "P6d")){idx=1026;}
      if(!strcmp(buf, "P7")){idx=1027;}
      if(!strcmp(buf, "P7d")){idx=1028;}
      if(!strcmp(buf, "P7n")){idx=1029;}
      if(!strcmp(buf, "P7nd")){idx=1030;}
      if(!strcmp(buf, "P8")){idx=1031;}
      if(!strcmp(buf, "P8d")){idx=1032;}
      if(!strcmp(buf, "P9")){idx=1033;}
      if(!strcmp(buf, "P9d")){idx=1034;}
      if(!strcmp(buf, "P9n")){idx=1035;}
      if(!strcmp(buf, "Pnd")){idx=1036;}

      if(!strcmp(buf, "P10")){idx=1037;}
      if(!strcmp(buf, "P10d")){idx=1038;}
      if(!strcmp(buf, "P10n")){idx=1039;}
      if(!strcmp(buf, "P10nd")){idx=1040;}
      if(!strcmp(buf, "P11")){idx=1041;}
      if(!strcmp(buf, "P11d")){idx=1042;}
      if(!strcmp(buf, "P12")){idx=1043;}
      if(!strcmp(buf, "P12d")){idx=1044;}
      if(!strcmp(buf, "P12n")){idx=1045;}
      if(!strcmp(buf, "P12nd")){idx=1046;}
      if(!strcmp(buf, "P13")){idx=1047;}
      if(!strcmp(buf, "P13d")){idx=1048;}
      if(!strcmp(buf, "P13n")){idx=1049;}
      if(!strcmp(buf, "P13nd")){idx=1050;}
      if(!strcmp(buf, "P14")){idx=1051;}
      if(!strcmp(buf, "P14d")){idx=1052;}
      if(!strcmp(buf, "P14n")){idx=1053;}
      if(!strcmp(buf, "P14nd")){idx=1054;}
      if(!strcmp(buf, "P15")){idx=1055;}
      if(!strcmp(buf, "P15d")){idx=1056;}
      if(!strcmp(buf, "P16")){idx=1057;}
      if(!strcmp(buf, "P16d")){idx=1058;}
      if(!strcmp(buf, "P16n")){idx=1059;}
      if(!strcmp(buf, "P16nd")){idx=1060;}
      if(!strcmp(buf, "P17")){idx=1061;}
      if(!strcmp(buf, "P17d")){idx=1062;}
      if(!strcmp(buf, "P17n")){idx=1063;}
      if(!strcmp(buf, "P17nd")){idx=1064;}
      if(!strcmp(buf, "P18")){idx=1065;}
      if(!strcmp(buf, "P18d")){idx=1066;}
      if(!strcmp(buf, "P18n")){idx=1067;}
      if(!strcmp(buf, "P18nd")){idx=1068;}
      if(!strcmp(buf, "Pbg")){idx=1069;}
      if(!strcmp(buf, "Pbgd")){idx=1070;}
      sprintf(buf2, "*G_%d", idx);
//END OF Ё[
      generate(&fp2,buf2);
    }else if(isWait(buf)){
      fgets(buf, sizeof(buf), fp);
      buf[strlen(buf)-2]='\0';//0x0a
      sprintf(buf2,"*W_%s", buf);
      generate(&fp2,buf2);
    }else if(isSpace(buf)){
      strcat(bank, "@@@@@@@@@@@@@@@@@");
    }else if(isGOff(buf)){
      generate(&fp2,"*O");
    }else if(isGFade(buf)){
      //NOP
    }else if(isJump(buf)){
      fgets(buf, sizeof(buf), fp);
      buf[strlen(buf)-1]='\0';//0x0a
      sprintf(buf2,"*J_%s", buf);
      generate(&fp2,buf2);
    }else if(isIndex(buf)){
      sprintf(buf2,"*I_%s", buf+7);
      generate(&fp2,buf2);
    }else if(isEnd(buf)){
      generate(&fp2,"*E");
    }else if(isSelect(buf)){
      do{
        fgets(buf, sizeof(buf), fp);
      }while(buf[0]=='-'&&buf[1]=='1');
      buf[strlen(buf)-1]='\0';//0x0a
      do{
        fgets(buf2, sizeof(buf2), fp);
        buf2[strlen(buf2)-1]='\0';//0x0a
        sprintf(buf3,"*S_%s",buf2);
        generate(&fp2,buf3);
        generate(&fp2,buf);
        fgets(buf, sizeof(buf), fp);
        buf[strlen(buf)-1]='\0';//0x0a
      }while(!isSelectEnd(buf));

    }else if(isNextpage(buf)){
      generate(&fp2,bank);
      generate(&fp2,"*P");
      bank[0]='\0';
    }else if(isNextline(buf)){
      generate(&fp2,bank);
      generate(&fp2,"*L");
      bank[0]='\0';
    }else{
     strcat(bank, buf);
    }
  }

  fclose(fp2);
  fclose(fp);

}


